/////////////////////////////////////////////////////////////////////
//
//            X   X           X
//           XXX XX         XX
//          XXXXXXXX      XXX
//         XX X XXXXXXXXXXX
//        XXXXX XXXXXXXXX
//       XXXXX XXXXXXXXXX
//            XXX XXX XXX
//           XXX XX   XX
//           X   X     X
//
//    Copyright (C) 2003-2019  Ron Jakl
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
/////////////////////////////////////////////////////////////////////

#ifndef BITFIELDWIDGETHEADERFILE
#define BITFIELDWIDGETHEADERFILE

#include <QFrame>

class QCheckBox;
class QLineEdit;

class TBitfieldWidget : public QFrame
{
Q_OBJECT

public:

// CREATORS
	TBitfieldWidget(const QWidget *parent=0, Qt::WindowFlags flags=0);
	~TBitfieldWidget(void);

// ACCESSORS
	int Integer(void) const;

// MANIPULATORS
	void Reset(void);
	void Set_Integer(const int value);

signals:
	void Value_Changed(const int index);	// index is always zero for a bit field

private slots:
	void Update_Integer(void);

private:
	QCheckBox							*d_b0_check;
	QCheckBox							*d_b1_check;
	QCheckBox							*d_b2_check;
	QCheckBox							*d_b3_check;
	QCheckBox							*d_b4_check;
	QCheckBox							*d_b5_check;
	QCheckBox							*d_b6_check;
	QCheckBox							*d_b7_check;
	QCheckBox							*d_b8_check;
	QCheckBox							*d_b9_check;
	QCheckBox							*d_b10_check;
	QCheckBox							*d_b11_check;
	QCheckBox							*d_b12_check;
	QCheckBox							*d_b13_check;
	QCheckBox							*d_b14_check;
	QCheckBox							*d_b15_check;
	QCheckBox							*d_b16_check;
	QCheckBox							*d_b17_check;
	QCheckBox							*d_b18_check;
	QCheckBox							*d_b19_check;
	QCheckBox							*d_b20_check;
	QCheckBox							*d_b21_check;
	QCheckBox							*d_b22_check;
	QCheckBox							*d_b23_check;
	QCheckBox							*d_b24_check;
	QCheckBox							*d_b25_check;
	QCheckBox							*d_b26_check;
	QCheckBox							*d_b27_check;
	QCheckBox							*d_b28_check;
	QCheckBox							*d_b29_check;
	QCheckBox							*d_b30_check;
	QCheckBox							*d_b31_check;
	QLineEdit							*d_value_edit;
	
	bool								d_signals_blocked;

// NOT IMPLEMENTED
	TBitfieldWidget(const TBitfieldWidget&);
	TBitfieldWidget& operator=(const TBitfieldWidget&);
};

#endif
