/////////////////////////////////////////////////////////////////////
//
//            X   X           X
//           XXX XX         XX
//          XXXXXXXX      XXX
//         XX X XXXXXXXXXXX
//        XXXXX XXXXXXXXX
//       XXXXX XXXXXXXXXX
//            XXX XXX XXX
//           XXX XX   XX
//           X   X     X
//
//    Copyright (C) 2003-2019  Ron Jakl
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
/////////////////////////////////////////////////////////////////////

#ifndef COPYRULESDIALOGHEADERFILE
#define COPYRULESDIALOGHEADERFILE

#include <QDialog>
#include <QStringList>

class QComboBox;
class QPushButton;

class TCopyRulesDialog : public QDialog
{
Q_OBJECT

public:

// CREATORS
	TCopyRulesDialog(const QWidget *parent=0, Qt::WindowFlags flags=0);
	~TCopyRulesDialog(void);

// ACCESSORS
	QString Target_Group(void) const;

// MANIPULATORS
	void Reset(const QStringList &available_groups);

signals:

private slots:

private:
	QComboBox							*d_group_combo;
	QPushButton							*d_cancel_button;
	QPushButton							*d_copy_button;

// NOT IMPLEMENTED
	TCopyRulesDialog(const TCopyRulesDialog&);
	TCopyRulesDialog& operator=(const TCopyRulesDialog&);
};

#endif
