/////////////////////////////////////////////////////////////////////
//
//            X   X           X
//           XXX XX         XX
//          XXXXXXXX      XXX
//         XX X XXXXXXXXXXX
//        XXXXX XXXXXXXXX
//       XXXXX XXXXXXXXXX
//            XXX XXX XXX
//           XXX XX   XX
//           X   X     X
//
//    Copyright (C) 2003-2019  Ron Jakl
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
/////////////////////////////////////////////////////////////////////

#ifndef CREATEGROUPDIALOGHEADERFILE
#define CREATEGROUPDIALOGHEADERFILE

#include <QDialog>
#include <QStringList>

class QLineEdit;
class QPushButton;

class TCreateGroupDialog : public QDialog
{
Q_OBJECT

public:

// CREATORS
	TCreateGroupDialog(const QWidget *parent=0, Qt::WindowFlags flags=0);
	~TCreateGroupDialog(void);

// ACCESSORS
	QString Group_Name(void) const;

// MANIPULATORS
	void Reset(const QStringList &existing_groups);

signals:

private slots:
	void Validate(const QString&);

private:
	QLineEdit							*d_group_name_edit;
	QPushButton							*d_cancel_button;
	QPushButton							*d_create_button;
	QStringList							d_existing_groups;

// NOT IMPLEMENTED
	TCreateGroupDialog(const TCreateGroupDialog&);
	TCreateGroupDialog& operator=(const TCreateGroupDialog&);
};

#endif
