/////////////////////////////////////////////////////////////////////
//
//            X   X           X
//           XXX XX         XX
//          XXXXXXXX      XXX
//         XX X XXXXXXXXXXX
//        XXXXX XXXXXXXXX
//       XXXXX XXXXXXXXXX
//            XXX XXX XXX
//           XXX XX   XX
//           X   X     X
//
//    Copyright (C) 2003-2019  Ron Jakl
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
/////////////////////////////////////////////////////////////////////

#ifndef RULEEDITORDIALOGHEADERFILE
#define RULEEDITORDIALOGHEADERFILE

#include <QDialog>
#include <QString>
#include <QStringList>

class QLabel;
class QListWidget;
class QListWidgetItem;
class QPushButton;
class TRules;
class TRuleItemDialog;
class TMessageBox;
class TCopyRulesDialog;

class TRuleEditorDialog : public QDialog
{
Q_OBJECT

public:

// CREATORS
	TRuleEditorDialog(const QWidget *parent=0, Qt::WindowFlags flags=0);
	~TRuleEditorDialog(void);

// ACCESSORS

// MANIPULATORS
	void Reset(const QString &rule_group,TRules * const rules);

signals:

private slots:
	void Rule_Selection_Changed(void);
	void Rule_Double_Clicked(QListWidgetItem*);
	
	void Add_Rule(void);
	void Edit_Rule(void);
	void Delete_Rule(void);
	void Copy_Rule(void);

private:
	QLabel								*d_rule_group_label;
	QListWidget							*d_rule_list;
	QPushButton							*d_add_rule_button;
	QPushButton							*d_copy_rule_button;
	QPushButton							*d_delete_rule_button;
	QPushButton							*d_edit_rule_button;
	TRuleItemDialog						*d_rule_item_dialog;
	TCopyRulesDialog					*d_copy_rules_dialog;
	TMessageBox							*d_msg_box;
	
	QString								d_rule_group;
	TRules								*d_rules;
	
// NOT IMPLEMENTED
	TRuleEditorDialog(const TRuleEditorDialog&);
	TRuleEditorDialog& operator=(const TRuleEditorDialog&);
};

#endif
