/////////////////////////////////////////////////////////////////////
//
//            X   X           X
//           XXX XX         XX
//          XXXXXXXX      XXX
//         XX X XXXXXXXXXXX
//        XXXXX XXXXXXXXX
//       XXXXX XXXXXXXXXX
//            XXX XXX XXX
//           XXX XX   XX
//           X   X     X
//
//    Copyright (C) 2003-2019  Ron Jakl
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
/////////////////////////////////////////////////////////////////////

#ifndef RULEITEMDIALOGHEADERFILE
#define RULEITEMDIALOGHEADERFILE

#include <QDialog>

#include "rules.h"

class QLineEdit;
class QPushButton;
class QRadioButton;

class TRuleItemDialog : public QDialog
{
Q_OBJECT

public:
enum TMode
{
	MODE_EDIT = 0,
	MODE_ADD
};

// CREATORS
	TRuleItemDialog(const QWidget *parent=0, Qt::WindowFlags flags=0);
	~TRuleItemDialog(void);

// ACCESSORS
	TRules::TRuleItem Rule_Item(void) const;

// MANIPULATORS
	void Reset(const TMode mode,const TRules::TRuleItem &rule_item,const QStringList &rule_item_names);

signals:

private slots:
	void Options_Changed(void);

private:
	QLineEdit							*d_left_expression_edit;
	QLineEdit							*d_right_expression_edit;
	QLineEdit							*d_rule_name_edit;
	QPushButton							*d_apply_button;
	QPushButton							*d_cancel_button;
	QRadioButton						*d_equal_radio;
	QRadioButton						*d_greater_radio;
	QRadioButton						*d_less_radio;
	QRadioButton						*d_not_equal_radio;
	QRadioButton						*d_not_greater_radio;
	QRadioButton						*d_not_less_radio;
	
	QStringList							d_rule_item_names;
	QString								d_active_rule_name;
	TRuleItemDialog::TMode				d_mode;
	
	bool Validate(void) const;

// NOT IMPLEMENTED
	TRuleItemDialog(const TRuleItemDialog&);
	TRuleItemDialog& operator=(const TRuleItemDialog&);
};

#endif
