/////////////////////////////////////////////////////////////////////
//
//            X   X           X
//           XXX XX         XX
//          XXXXXXXX      XXX
//         XX X XXXXXXXXXXX
//        XXXXX XXXXXXXXX
//       XXXXX XXXXXXXXXX
//            XXX XXX XXX
//           XXX XX   XX
//           X   X     X
//
//    Copyright (C) 2003-2019  Ron Jakl
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
/////////////////////////////////////////////////////////////////////

#include <cmath>
#include <assert.h>

#include "utilities.h"

bool Utilities::Use_High_Precision_Display(
	const double						&value)
{
	double								fval(fabs(value));
	double								rval;
	int									ival(static_cast<int>(fval + 0.5));
	static const double					PRECISION_LEVEL(10000.0);
	static const double					ZERO_EPSILON(0.000000000001);
	
	fval -= static_cast<double>(ival);
	
	rval = fval * PRECISION_LEVEL;
	rval -= static_cast<double>(static_cast<int>(fval * PRECISION_LEVEL));
	
	return (rval > ZERO_EPSILON);
}
