/////////////////////////////////////////////////////////////////////
//
//            X   X           X
//           XXX XX         XX
//          XXXXXXXX      XXX
//         XX X XXXXXXXXXXX
//        XXXXX XXXXXXXXX
//       XXXXX XXXXXXXXXX
//            XXX XXX XXX
//           XXX XX   XX
//           X   X     X
//
//    Copyright (C) 2003-2019  Ron Jakl
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
/////////////////////////////////////////////////////////////////////

#ifndef VALUESWIDGETHEADERFILE
#define VALUESWIDGETHEADERFILE

#include <QFrame>
#include <vector>

class QLabel;
class QLineEdit;
class QGridLayout;

class TValuesWidget : public QFrame
{
Q_OBJECT

public:

// CREATORS
	TValuesWidget(const QWidget *parent=0, Qt::WindowFlags flags=0);
	~TValuesWidget(void);

// ACCESSORS
	int Integer(const int index) const;
	double Float(const int index) const;
	QString Text(const int index) const;

// MANIPULATORS
	void Reset(const int values_count);
	
	void Set_Integer(const int index,const int value);
	void Set_Float(const int index,const double &value);
	void Set_Text(const int index, const QString &text);

signals:
	void Value_Changed(const int index);

private slots:
	void Value_Changed(void);

private:
	
struct TValueWidget
{
	QLabel								*index_label;
	QLineEdit							*value_edit;
	int									index;
};
	QGridLayout							*d_values_layout;
	
	std::vector<TValueWidget>			d_value_widgets;
	
	
// NOT IMPLEMENTED
	TValuesWidget(const TValuesWidget&);
	TValuesWidget& operator=(const TValuesWidget&);
};

#endif
