/////////////////////////////////////////////////////////////////////
//
//            X   X           X
//           XXX XX         XX
//          XXXXXXXX      XXX
//         XX X XXXXXXXXXXX
//        XXXXX XXXXXXXXX
//       XXXXX XXXXXXXXXX
//            XXX XXX XXX
//           XXX XX   XX
//           X   X     X
//
//    Copyright (C) 2003-2019  Ron Jakl
//
//    This program is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    This program is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
/////////////////////////////////////////////////////////////////////

#ifndef EVENTFILTERSHEADERFILE
#define EVENTFILTERSHEADERFILE

#include <QObject>
#include <QList>
#include <QUrl>

class QEvent;
class QTimer;

class TDragDropFileEventFilter : public QObject
{
Q_OBJECT
public:
// CREATORS
	TDragDropFileEventFilter(const QObject *parent=0);
	virtual ~TDragDropFileEventFilter(void);
	
// ACCESSORS
	
// MANIPULATORS
	
signals:
	void Drop_Complete(void);
	
protected:
	virtual bool eventFilter(QObject *object, QEvent *event);
	
private:
	QTimer								*d_signal_timer;
	
// NOT IMPLEMENTED
	TDragDropFileEventFilter(const TDragDropFileEventFilter&);
	TDragDropFileEventFilter& operator=(const TDragDropFileEventFilter&);
};


class TDragDropDirEventFilter : public QObject
{
	Q_OBJECT
public:
	// CREATORS
	TDragDropDirEventFilter(const QObject *parent=0);
	virtual ~TDragDropDirEventFilter(void);
	
	// ACCESSORS
	
	// MANIPULATORS
	
signals:
	void Drop_Complete(void);

protected:
	virtual bool eventFilter(QObject *object, QEvent *event);
	
private:
	QTimer								*d_signal_timer;
	
	QList<QUrl> Convert_To_Directories(const QList<QUrl> &urls) const;
	
	// NOT IMPLEMENTED
	TDragDropDirEventFilter(const TDragDropDirEventFilter&);
	TDragDropDirEventFilter& operator=(const TDragDropDirEventFilter&);
};

#endif
